#include <stdio.h>
#include <windows.h>
#include "z80/defs.h"

HWND win_dbg;
HWND but_step;
char tmp_str[256];
unsigned short tmp0, tmp1;

unsigned cur_ctrl;
//unsigned long iter;

FILE *proc_log;
struct
{
	HWND r_ir, r_pc, r_sp, r_ix, r_iy;
	HWND r_af, r_bc, r_de, r_hl;
	HWND r_af_, r_bc_, r_de_, r_hl_;
} ctrls;

BOOL CALLBACK win_enum(HWND hwnd, LPARAM lParam)
{
	switch(cur_ctrl++)
	{
		case  1: ctrls.r_ir = hwnd; break;
		case  2: ctrls.r_pc = hwnd; break;
		case  3: ctrls.r_sp = hwnd; break;
		case  4: ctrls.r_ix = hwnd; break;
		case  5: ctrls.r_iy = hwnd; break;
		case  6: ctrls.r_hl = hwnd; break;
		case  7: ctrls.r_de = hwnd; break;
		case  8: ctrls.r_bc = hwnd; break;
		case  9: ctrls.r_af = hwnd; break;
		case 10: ctrls.r_hl_ = hwnd; break;
		case 11: ctrls.r_de_ = hwnd; break;
		case 12: ctrls.r_bc_ = hwnd; break;
		case 13: ctrls.r_af_ = hwnd; break;		
	}	
	return true;
}

void cmpr_compare(Z80 *cpu)
{
	bool diff = 0;
	Z80 gmxcpu;
	
	SendMessage(ctrls.r_pc, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.pc);
	SendMessage(ctrls.r_af, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.af);
	SendMessage(ctrls.r_bc, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.bc);
	SendMessage(ctrls.r_de, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.de);
	SendMessage(ctrls.r_hl, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.hl);
	SendMessage(ctrls.r_af_, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.alt.af);
	SendMessage(ctrls.r_bc_, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.alt.bc);
	SendMessage(ctrls.r_de_, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.alt.de);
	SendMessage(ctrls.r_hl_, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.alt.hl);
	SendMessage(ctrls.r_ix, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.ix);
	SendMessage(ctrls.r_iy, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.iy);
	SendMessage(ctrls.r_sp, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.sp);		
	SendMessage(ctrls.r_ir, WM_GETTEXT, 256, (LPARAM)tmp_str);
	sscanf(tmp_str, "%X", &gmxcpu.ir_);
			
	SendMessage(but_step, BM_CLICK, 0 , 0);
	
	if ((cpu->pc & 0xFFFF) != (gmxcpu.pc & 0xFFFF)) diff = 1;
	if ((cpu->af & 0xFF00) != (gmxcpu.af & 0xFF00)) diff = 1;
	/*if ((cpu->alt.af & 0xFF00) != (gmxcpu.alt.af & 0xFF00)) diff = 1;
	if ((cpu->bc & 0xFFFF) != (gmxcpu.bc & 0xFFFF)) diff = 1;
	if ((cpu->de & 0xFFFF) != (gmxcpu.de & 0xFFFF)) diff = 1;
	if ((cpu->hl & 0xFFFF) != (gmxcpu.hl & 0xFFFF)) diff = 1;
	if ((cpu->alt.bc & 0xFFFF) != (gmxcpu.alt.bc & 0xFFFF)) diff = 1;
	if ((cpu->alt.de & 0xFFFF) != (gmxcpu.alt.de & 0xFFFF)) diff = 1;
	if ((cpu->alt.hl & 0xFFFF) != (gmxcpu.alt.hl & 0xFFFF)) diff = 1;
	if ((cpu->sp & 0xFFFF) != (gmxcpu.sp & 0xFFFF)) diff = 1;
	if ((cpu->ix & 0xFFFF) != (gmxcpu.ix & 0xFFFF)) diff = 1;
	if ((cpu->iy & 0xFFFF) != (gmxcpu.iy & 0xFFFF)) diff = 1;
	if ((cpu->ir_ & 0xFF00) != (gmxcpu.ir_ & 0xFF00)) diff = 1;*/
	
	if (diff)
	{
		fprintf(proc_log, "U %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X\n",
			cpu->pc, cpu->af, cpu->bc, cpu->de, cpu->hl,
			cpu->alt.af, cpu->alt.bc, cpu->alt.de, cpu->alt.hl,
			cpu->ix, cpu->iy, cpu->sp, cpu->ir_);
		fprintf(proc_log, "G %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X %.4X\n\n",
			gmxcpu.pc, gmxcpu.af, gmxcpu.bc, gmxcpu.de, gmxcpu.hl,
			gmxcpu.alt.af, gmxcpu.alt.bc, gmxcpu.alt.de, gmxcpu.alt.hl,
			gmxcpu.ix, gmxcpu.iy, gmxcpu.sp, gmxcpu.ir_);
	}
}

void cmpr_init()
{
	win_dbg = FindWindow(NULL, "Debugger");
	if (win_dbg)
	{
		printf("Window %.8X\n", win_dbg);
		cur_ctrl = 0;
		EnumChildWindows(win_dbg, win_enum, 0);
		
		but_step = FindWindowEx(win_dbg, 0, "Button", "Step");
		
		proc_log = fopen("log.txt", "wt");
		
		fprintf(proc_log, "E _PC_ _AF_ _BC_ _DE_ _HL_ _AF' _BC' _DE' _HL' _IX_ _IY_ _SP_ _IR_\n");
	}
}
		
void cmpr_uninit()
{
	if (proc_log)
		fclose(proc_log);
}