
void line8_gmx(unsigned char *dst, unsigned char *src, unsigned *tab0)
{
   for (unsigned x = 0; x < 640; x += 16) {
      unsigned s = *(unsigned*)src;
      unsigned at = *(unsigned*)(src + 0x40*PAGE);
      unsigned *tab = tab0 + ((colortab[at&0xFF] << 4) & 0xFF0);
      *(unsigned*)(dst+x)   = tab[((s >> 4) & 0xF)];
      *(unsigned*)(dst+x+4) = tab[((s >> 0) & 0xF)];
      tab = tab0 + ((colortab[(at>>8)&0xFF] << 4) & 0xFF0);
      *(unsigned*)(dst+x+8) = tab[((s >>12) & 0xF)];
      *(unsigned*)(dst+x+12)= tab[((s >> 8) & 0xF)];
      src += 2;
   }
}

void line16_gmx(unsigned char *dst, unsigned char *src, unsigned *tab0)
{
   for (unsigned x = 0; x < 640*2; x += 32) {
      unsigned s = *(unsigned*)src;
      unsigned at = *(unsigned*)(src + 0x40*PAGE);
      unsigned *tab = tab0 + ((colortab[at&0xFF] << 2) & 0x3FC);
      *(unsigned*)(dst+x)   = tab[((s >> 6) & 3)];
      *(unsigned*)(dst+x+4) = tab[((s >> 4) & 3)];
      *(unsigned*)(dst+x+8) = tab[((s >> 2) & 3)];
      *(unsigned*)(dst+x+12)= tab[((s >> 0) & 3)];
      tab = tab0 + ((colortab[(at>>8)&0xFF] << 2) & 0x3FC);
      *(unsigned*)(dst+x+16)= tab[((s >>14) & 3)];
      *(unsigned*)(dst+x+20)= tab[((s >>12) & 3)];
      *(unsigned*)(dst+x+24)= tab[((s >>10) & 3)];
      *(unsigned*)(dst+x+28)= tab[((s >> 8) & 3)];
      src += 2;
   }
}

void line32_gmx(unsigned char *dst, unsigned char *src, unsigned *tab0)
{
   for (unsigned x = 0; x < 640*4; x += 64) {
      unsigned s =  *(unsigned*)src;
      unsigned at = *(unsigned*)(src + 0x40*PAGE);
      unsigned *tab = tab0 + colortab[at&0xFF];
      *(unsigned*)(dst+x)    = tab[((s << 1) & 0x100)];
      *(unsigned*)(dst+x+4)  = tab[((s << 2) & 0x100)];
      *(unsigned*)(dst+x+8)  = tab[((s << 3) & 0x100)];
      *(unsigned*)(dst+x+12) = tab[((s << 4) & 0x100)];
      *(unsigned*)(dst+x+16) = tab[((s << 5) & 0x100)];
      *(unsigned*)(dst+x+20) = tab[((s << 6) & 0x100)];
      *(unsigned*)(dst+x+24) = tab[((s << 7) & 0x100)];
      *(unsigned*)(dst+x+28) = tab[((s << 8) & 0x100)];
      tab = tab0 + colortab[(at>>8)&0xFF];
      *(unsigned*)(dst+x+32) = tab[((s >> 7) & 0x100)];
      *(unsigned*)(dst+x+36) = tab[((s >> 6) & 0x100)];
      *(unsigned*)(dst+x+40) = tab[((s >> 5) & 0x100)];
      *(unsigned*)(dst+x+44) = tab[((s >> 4) & 0x100)];
      *(unsigned*)(dst+x+48) = tab[((s >> 3) & 0x100)];
      *(unsigned*)(dst+x+52) = tab[((s >> 2) & 0x100)];
      *(unsigned*)(dst+x+56) = tab[((s >> 1) & 0x100)];
      *(unsigned*)(dst+x+60) = tab[((s >> 0) & 0x100)];
      src += 2;
   }
}

void r_gmx_8(unsigned char *dst, unsigned pitch, unsigned char *base)
{
   unsigned max = min(200, temp.scy);
   for (unsigned y = 0; y < max; y++) {
      line8_gmx(dst, base + y*80, t.sctab8[0]);
      dst += pitch;
   }
}

void r_gmx_8d(unsigned char *dst, unsigned pitch, unsigned char *base)
{
   unsigned max = min(200, temp.scy);
   for (unsigned y = 0; y < max; y++) {
      line8_gmx(dst, base + y*80, t.sctab8[0]); dst += pitch;
      line8_gmx(dst, base + y*80, t.sctab8[1]); dst += pitch;
   }
}

void r_gmx_16(unsigned char *dst, unsigned pitch, unsigned char *base)
{
   unsigned max = min(200, temp.scy);
   for (unsigned y = 0; y < max; y++) {
      line16_gmx(dst, base + y*80, t.sctab16[0]);
      dst += pitch;
   }
}

void r_gmx_16d(unsigned char *dst, unsigned pitch, unsigned char *base)
{
   unsigned max = min(200, temp.scy);
   for (unsigned y = 0; y < max; y++) {
      line16_gmx(dst, base + y*80, t.sctab16[0]); dst += pitch;
      line16_gmx(dst, base + y*80, t.sctab16[1]); dst += pitch;
   }
}

void r_gmx_32(unsigned char *dst, unsigned pitch, unsigned char *base)
{
   unsigned max = min(200, temp.scy);
   for (unsigned y = 0; y < max; y++) {
      line32_gmx(dst, base + y*80, t.sctab32[0]);//t.scrtab[y], t.zctab32[0]);
      dst += pitch;
   }
}

void r_gmx_32d(unsigned char *dst, unsigned pitch, unsigned char *base)
{
   unsigned max = min(200, temp.scy);
   for (unsigned y = 0; y < max; y++) {
      line32_gmx(dst, base + y*80, t.sctab32[0]); dst += pitch;
      line32_gmx(dst, base + y*80, t.sctab32[1]); dst += pitch;
   }
}

void rend_gmx(unsigned char *dst, unsigned pitch)
{
   unsigned char *dst2 = dst + (temp.ox-640)*temp.obpp/16;
   if (temp.scy > 200) dst2 += (temp.scy-200)/2*pitch * ((temp.oy > temp.scy)?2:1);
   if (temp.oy > temp.scy && conf.fast_sl) pitch *= 2;

   unsigned char *base = memory + ((comp.p7FFD & 0x08)? 0x3B*PAGE : 0x39*PAGE);
   if (temp.obpp == 8)  { if (conf.fast_sl) r_gmx_8 (dst2, pitch, base); else r_gmx_8d (dst2, pitch, base); return; }
   if (temp.obpp == 16) { if (conf.fast_sl) r_gmx_16(dst2, pitch, base); else r_gmx_16d(dst2, pitch, base); return; }
   if (temp.obpp == 32) { if (conf.fast_sl) r_gmx_32(dst2, pitch, base); else r_gmx_32d(dst2, pitch, base); return; }
}
